Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVector.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVector.cs	(revision 9226)
@@ -54,6 +54,6 @@
     protected VariableVector(VariableVector original, Cloner cloner)
       : base(original, cloner) {
-      condition = new VariableVectorCondition(original.condition);
-      action = new VariableVectorAction(original.action);
+      condition = (VariableVectorCondition)original.condition.Clone();
+      action = (VariableVectorAction)original.action;
     }
     public VariableVector() {
@@ -64,5 +64,5 @@
       : this() {
       if (condition == null || action == null) { throw new ArgumentNullException(); }
-      if (action.All(x => x is IActionVariable)) { throw new ArgumentException("Action can only use IActionVariable"); }
+      if (!action.All(x => x is IActionVariable)) { throw new ArgumentException("Action can only use IActionVariable"); }
       this.Condition.Add(condition);
       this.Action.Add(action.Cast<IActionVariable>());
@@ -70,4 +70,8 @@
     public override IDeepCloneable Clone(Cloner cloner) {
       return new VariableVector(this, cloner);
+    }
+
+    public VariableVector GetEmptyCopy() {
+      return new VariableVector(Condition.Values.Select(x => x.GetEmptyCopy()), Action.Values.Select(x => x.GetEmptyCopy()));
     }
 
@@ -128,41 +132,7 @@
       var targetCast = target as VariableVector;
       if (targetCast == null) { return false; }
-      if (!condition.Identical(targetCast.condition)) { return false; }
-      if (!action.Identical(targetCast.condition)) { return false; }
+      if (!condition.Identical(targetCast.Condition)) { return false; }
+      if (!action.Identical(targetCast.Action)) { return false; }
       return true;
-    }
-
-    [StorableClass]
-    [Item("VariableVectorActionComparer", "")]
-    public class VariableVectorActionComparer : Item, IEqualityComparer<VariableVectorAction>, IClassifierComparer {
-
-      [StorableConstructor]
-      protected VariableVectorActionComparer(bool deserializing) : base(deserializing) { }
-      protected VariableVectorActionComparer(VariableVectorActionComparer original, Cloner cloner)
-        : base(original, cloner) {
-      }
-      public override IDeepCloneable Clone(Cloner cloner) {
-        return new VariableVectorActionComparer(this, cloner);
-      }
-      public VariableVectorActionComparer() : base() { }
-
-      public bool Equals(VariableVectorAction x, VariableVectorAction y) {
-        throw new NotImplementedException();
-      }
-
-      public int GetHashCode(VariableVectorAction obj) {
-        throw new NotImplementedException();
-      }
-
-      public bool Equals(IAction x, IAction y) {
-        var xCast = x as VariableVectorAction;
-        var yCast = y as VariableVectorAction;
-        return x != null && y != null && Equals(xCast, yCast);
-      }
-
-      public int GetHashCode(IAction obj) {
-        var objCast = obj as VariableVectorAction;
-        return objCast != null ? GetHashCode(objCast) : obj.GetHashCode();
-      }
     }
   }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorAction.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorAction.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorAction.cs	(revision 9226)
@@ -22,9 +22,9 @@
 using System;
 using System.Collections.Generic;
+using System.Drawing;
 using System.Linq;
 using System.Text;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Encodings.ConditionActionEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -33,29 +33,43 @@
   [StorableClass]
   [Item("VariableVectorAction", "")]
-  public class VariableVectorAction : ItemDictionary<StringValue, IActionVariable>, IAction {
+  public class VariableVectorAction : Dictionary<string, IActionVariable>, IAction {
 
-    public IOrderedEnumerable<StringValue> Order { get { return this.Keys.OrderBy(x => x.Value); } }
+    public IOrderedEnumerable<string> Order { get { return this.Keys.OrderBy(x => x); } }
 
     public int VirtualLength { get { return this.Values.Sum(x => x.VirtualLength); } }
 
     [StorableConstructor]
-    protected VariableVectorAction(bool deserializing) : base(deserializing) { }
-    protected VariableVectorAction(VariableVectorAction original, Cloner cloner)
-      : base(original, cloner) {
+    protected VariableVectorAction(bool deserializing) { }
+    protected VariableVectorAction(VariableVectorAction original, Cloner cloner) {
+      foreach (var item in original) {
+        Add((string)item.Key.Clone(), (IActionVariable)item.Value.Clone());
+      }
     }
     public VariableVectorAction() : base() { }
     public VariableVectorAction(int capacity) : base(capacity) { }
-    public VariableVectorAction(IDictionary<StringValue, IActionVariable> dictionary) : base(dictionary) { }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new VariableVectorAction(this, cloner);
+    public VariableVectorAction(IDictionary<string, IActionVariable> dictionary) : base(dictionary) { }
+
+    //protected override void OnItemsAdded(IEnumerable<KeyValuePair<string, IActionVariable>> items) {
+    //  foreach (var item in items) {
+    //    if (!(item.Value is StringVariable || item.Value is IntVariable)) {
+    //      throw new ArgumentException("Value has to be of type 'StringVariable' or 'IntVariable'");
+    //    }
+    //  }
+    //}
+
+    public VariableVectorAction GetEmptyCopy() {
+      VariableVectorAction emptyCopy = new VariableVectorAction(this.Count);
+      foreach (var keyValuePair in this) {
+        emptyCopy.Add(keyValuePair.Key, keyValuePair.Value.GetEmptyCopy());
+      }
+      return emptyCopy;
     }
 
-    protected override void OnItemsAdded(IEnumerable<KeyValuePair<StringValue, IActionVariable>> items) {
-      foreach (var item in items) {
-        if (!(item.Value is StringVariable || item.Value is IntVariable)) {
-          throw new ArgumentException("Value has to be of type 'StringVariable' or 'IntVariable'");
-        }
+    public VariableVectorAction GetSetCopy() {
+      VariableVectorAction setCopy = new VariableVectorAction(this.Count);
+      foreach (var keyValuePair in this) {
+        setCopy.Add(keyValuePair.Key, keyValuePair.Value.GetSetCopy());
       }
-      base.OnItemsAdded(items);
+      return setCopy;
     }
 
@@ -63,5 +77,5 @@
       var targetCast = target as VariableVectorAction;
       if (targetCast == null) { return false; }
-      if (this.Order.SequenceEqual(targetCast.Order)) { return false; }
+      if (!this.Order.SequenceEqual(targetCast.Order)) { return false; }
       foreach (var keyValuePair in targetCast) {
         if (!this[keyValuePair.Key].MatchVariable(keyValuePair.Value)) {
@@ -74,5 +88,5 @@
     public void Add(IEnumerable<IActionVariable> action) {
       foreach (var variable in action) {
-        this.Add(new StringValue(variable.VariableName), variable);
+        this.Add(variable.VariableName, variable);
       }
     }
@@ -82,5 +96,5 @@
       bool first = true;
       foreach (var variable in this.Values) {
-        if (!first) {
+        if (first) {
           first = false;
         } else {
@@ -98,5 +112,5 @@
     }
 
-    public bool Identical(VariableVectorCondition target) {
+    public bool Identical(VariableVectorAction target) {
       if (this.Order.SequenceEqual(target.Order)) { return false; }
       foreach (var keyValuePair in target) {
@@ -107,4 +121,39 @@
       return true;
     }
+
+    public virtual string ItemName {
+      get { return ItemAttribute.GetName(this.GetType()); }
+    }
+    public virtual string ItemDescription {
+      get { return ItemAttribute.GetDescription(this.GetType()); }
+    }
+    public Version ItemVersion {
+      get { return ItemAttribute.GetVersion(this.GetType()); }
+    }
+    public static Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
+    }
+    public virtual Image ItemImage {
+      get { return ItemAttribute.GetImage(this.GetType()); }
+    }
+
+    public virtual IDeepCloneable Clone(Cloner cloner) {
+      return new VariableVectorAction(this, cloner);
+    }
+
+    public object Clone() {
+      return Clone(new Cloner());
+    }
+
+    public event EventHandler ItemImageChanged;
+    protected virtual void OnItemImageChanged() {
+      EventHandler handler = ItemImageChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler ToStringChanged;
+    protected virtual void OnToStringChanged() {
+      EventHandler handler = ToStringChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorActionComparer.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorActionComparer.cs	(revision 9226)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorActionComparer.cs	(revision 9226)
@@ -0,0 +1,77 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ConditionActionEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.VariableVector {
+  [StorableClass]
+  [Item("VariableVectorActionComparer", "")]
+  public class VariableVectorActionComparer : Item, IEqualityComparer<VariableVectorAction>, IClassifierComparer {
+
+    [StorableConstructor]
+    protected VariableVectorActionComparer(bool deserializing) : base(deserializing) { }
+    protected VariableVectorActionComparer(VariableVectorActionComparer original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new VariableVectorActionComparer(this, cloner);
+    }
+    public VariableVectorActionComparer() : base() { }
+
+    public bool Equals(VariableVectorAction x, VariableVectorAction y) {
+      if (!x.Order.SequenceEqual(y.Order)) return false;
+      foreach (var key in x.Keys) {
+        if (!x[key].Identical(y[key])) {
+          return false;
+        }
+      }
+      return true;
+    }
+
+    public int GetHashCode(VariableVectorAction obj) {
+      int result = 1;
+      foreach (var key in obj.Keys) {
+        result = 37 * result + key.GetHashCode();
+      }
+
+      foreach (var val in obj.Values) {
+        result = 37 * result + val.GetHashCode();
+      }
+      return result;
+    }
+
+    public bool Equals(IAction x, IAction y) {
+      var xCast = x as VariableVectorAction;
+      var yCast = y as VariableVectorAction;
+      return x != null && y != null && Equals(xCast, yCast);
+    }
+
+    public int GetHashCode(IAction obj) {
+      var objCast = obj as VariableVectorAction;
+      return objCast != null ? GetHashCode(objCast) : obj.GetHashCode();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCondition.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCondition.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCondition.cs	(revision 9226)
@@ -20,10 +20,11 @@
 #endregion
 
+using System;
 using System.Collections.Generic;
+using System.Drawing;
 using System.Linq;
 using System.Text;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Encodings.ConditionActionEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -32,28 +33,27 @@
   [StorableClass]
   [Item("VariableVectorCondition", "")]
-  public class VariableVectorCondition : ItemDictionary<StringValue, IVariable>, ICondition {
+  public class VariableVectorCondition : Dictionary<string, IVariable>, ICondition {
 
-    public IOrderedEnumerable<StringValue> Order { get { return this.Keys.OrderBy(x => x.Value); } }
+    public IOrderedEnumerable<string> Order { get { return this.Keys.OrderBy(x => x); } }
 
     public int VirtualLength { get { return this.Values.Sum(x => x.VirtualLength); } }
 
     [StorableConstructor]
-    protected VariableVectorCondition(bool deserializing) : base(deserializing) { }
-    protected VariableVectorCondition(VariableVectorCondition original, Cloner cloner)
-      : base(original, cloner) {
+    protected VariableVectorCondition(bool deserializing) { }
+    protected VariableVectorCondition(VariableVectorCondition original, Cloner cloner) {
+      foreach (var item in original) {
+        Add((string)item.Key.Clone(), (IVariable)item.Value.Clone());
+      }
     }
     public VariableVectorCondition() : base() { }
     public VariableVectorCondition(int capacity) : base(capacity) { }
-    public VariableVectorCondition(IDictionary<StringValue, IVariable> dictionary) : base(dictionary) { }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new VariableVectorCondition(this, cloner);
-    }
+    public VariableVectorCondition(IDictionary<string, IVariable> dictionary) : base(dictionary) { }
 
     public bool Match(IInput target) {
       var targetCast = target as VariableVectorInput;
       if (targetCast == null) { return false; }
-      if (this.Order.SequenceEqual(targetCast.Order)) { return false; }
-      foreach (var keyValuePair in targetCast) {
-        if (!this[keyValuePair.Key].MatchInput(keyValuePair.Value.Value)) {
+      if (!this.Keys.All(x => targetCast.Keys.Contains(x))) { return false; }
+      foreach (var key in this.Keys) {
+        if (!this[key].MatchInput(targetCast[key])) {
           return false;
         }
@@ -64,5 +64,5 @@
     public void Add(IEnumerable<IVariable> condition) {
       foreach (var variable in condition) {
-        this.Add(new StringValue(variable.VariableName), variable);
+        this.Add(variable.VariableName, variable);
       }
     }
@@ -72,5 +72,5 @@
       bool first = true;
       foreach (var variable in this.Values) {
-        if (!first) {
+        if (first) {
           first = false;
         } else {
@@ -93,5 +93,5 @@
 
     public bool Identical(VariableVectorCondition target) {
-      if (this.Order.SequenceEqual(target.Order)) { return false; }
+      if (!this.Order.SequenceEqual(target.Order)) { return false; }
       foreach (var keyValuePair in target) {
         if (!this[keyValuePair.Key].Identical(keyValuePair.Value)) {
@@ -101,4 +101,39 @@
       return true;
     }
+
+    public virtual string ItemName {
+      get { return ItemAttribute.GetName(this.GetType()); }
+    }
+    public virtual string ItemDescription {
+      get { return ItemAttribute.GetDescription(this.GetType()); }
+    }
+    public Version ItemVersion {
+      get { return ItemAttribute.GetVersion(this.GetType()); }
+    }
+    public static Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
+    }
+    public virtual Image ItemImage {
+      get { return ItemAttribute.GetImage(this.GetType()); }
+    }
+
+    public virtual IDeepCloneable Clone(Cloner cloner) {
+      return new VariableVectorCondition(this, cloner);
+    }
+
+    public object Clone() {
+      return Clone(new Cloner());
+    }
+
+    public event EventHandler ItemImageChanged;
+    protected virtual void OnItemImageChanged() {
+      EventHandler handler = ItemImageChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler ToStringChanged;
+    protected virtual void OnToStringChanged() {
+      EventHandler handler = ToStringChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorInput.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorInput.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorInput.cs	(revision 9226)
@@ -20,9 +20,11 @@
 #endregion
 
+using System;
 using System.Collections.Generic;
+using System.Drawing;
 using System.Linq;
+using System.Text;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Encodings.ConditionActionEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -31,18 +33,66 @@
   [StorableClass]
   [Item("VariableVectorInput", "")]
-  public class VariableVectorInput : ItemDictionary<StringValue, StringValue>, IInput {
+  public class VariableVectorInput : Dictionary<string, string>, IInput {
 
-    public IOrderedEnumerable<StringValue> Order { get { return this.Keys.OrderBy(x => x.Value); } }
+    public IOrderedEnumerable<string> Order { get { return this.Keys.OrderBy(x => x); } }
 
     [StorableConstructor]
-    protected VariableVectorInput(bool deserializing) : base(deserializing) { }
-    protected VariableVectorInput(VariableVectorInput original, Cloner cloner)
-      : base(original, cloner) {
+    protected VariableVectorInput(bool deserializing) { }
+    protected VariableVectorInput(VariableVectorInput original, Cloner cloner) {
+      foreach (var item in original) {
+        Add((string)item.Key.Clone(), (string)item.Value.Clone());
+      }
     }
     public VariableVectorInput() : base() { }
     public VariableVectorInput(int capacity) : base(capacity) { }
-    public VariableVectorInput(IDictionary<StringValue, StringValue> dictionary) : base(dictionary) { }
-    public override IDeepCloneable Clone(Cloner cloner) {
+    public VariableVectorInput(IDictionary<string, string> dictionary) : base(dictionary) { }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      bool first = true;
+      foreach (var item in this) {
+        if (first) {
+          first = false;
+        } else {
+          sb.Append("; ");
+        }
+        sb.Append(String.Format("{0}: {1}", item.Key, item.Value));
+      }
+      return sb.ToString();
+    }
+
+    public virtual string ItemName {
+      get { return ItemAttribute.GetName(this.GetType()); }
+    }
+    public virtual string ItemDescription {
+      get { return ItemAttribute.GetDescription(this.GetType()); }
+    }
+    public Version ItemVersion {
+      get { return ItemAttribute.GetVersion(this.GetType()); }
+    }
+    public static Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
+    }
+    public virtual Image ItemImage {
+      get { return ItemAttribute.GetImage(this.GetType()); }
+    }
+
+    public virtual IDeepCloneable Clone(Cloner cloner) {
       return new VariableVectorInput(this, cloner);
+    }
+
+    public object Clone() {
+      return Clone(new Cloner());
+    }
+
+    public event EventHandler ItemImageChanged;
+    protected virtual void OnItemImageChanged() {
+      EventHandler handler = ItemImageChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler ToStringChanged;
+    protected virtual void OnToStringChanged() {
+      EventHandler handler = ToStringChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
     }
   }
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.CombinedIntegerVectorClassification/3.3/CombinedIntegerVectorClassificationProblem.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.CombinedIntegerVectorClassification/3.3/CombinedIntegerVectorClassificationProblem.cs	(revision 9226)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.CombinedIntegerVectorClassification/3.3/CombinedIntegerVectorClassificationProblem.cs	(revision 9226)
@@ -0,0 +1,176 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.CombinedIntegerVectorEncoding;
+using HeuristicLab.Encodings.ConditionActionEncoding;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.ConditionActionClassification;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Problems.CombinedIntegerVectorClassification {
+  [StorableClass]
+  public class CombinedIntegerVectorClassificationProblem : ConditionActionClassificationProblem<UniformRandomCombinedIntegerVectorCreator,
+                                                            CombinedIntegerVectorComparer,
+                                                            CombinedIntegerVectorClassificationProblemData> {
+    public override string ChildName {
+      get { return "CombinedIntegerVector"; }
+    }
+
+    #region parameter properties
+    private IFixedValueParameter<ItemSet<CombinedIntegerVector>> PossibleActionsConcreteClassParameter {
+      get { return (IFixedValueParameter<ItemSet<CombinedIntegerVector>>)Parameters["PossibleActionsConcreteClass"]; }
+    }
+    public override IFixedValueParameter<CombinedIntegerVectorComparer> ClassifierComparerParameter {
+      get { return (IFixedValueParameter<CombinedIntegerVectorComparer>)Parameters["ClassifierComparer"]; }
+    }
+    #endregion
+
+    #region properties
+    public new CombinedIntegerVectorClassificationProblemData ProblemData {
+      get { return ProblemDataParameter.Value; }
+      protected set {
+        ProblemDataParameter.Value = value;
+        if (value != null) {
+          SetProblemDataSpecificParameters();
+        }
+      }
+    }
+
+    public ItemSet<CombinedIntegerVector> PossibleActionsConcreteClass {
+      get { return PossibleActionsConcreteClassParameter.Value; }
+    }
+    public IClassifierComparer ClassifierComparer {
+      get { return ClassifierComparerParameter.Value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected CombinedIntegerVectorClassificationProblem(bool deserializing) : base(deserializing) { }
+    protected CombinedIntegerVectorClassificationProblem(CombinedIntegerVectorClassificationProblem original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new CombinedIntegerVectorClassificationProblem(this, cloner);
+    }
+
+    public CombinedIntegerVectorClassificationProblem() :
+      this(new CombinedIntegerVectorClassificationProblemData(new Dataset(ConditionActionClassificationProblemData.defaultVariableNames, ConditionActionClassificationProblemData.defaultData),
+        ConditionActionClassificationProblemData.defaultVariableNames.Take(ConditionActionClassificationProblemData.defaultVariableNames.Length - 1), ConditionActionClassificationProblemData.defaultVariableNames.Last().ToEnumerable()),
+        new XCSEvaluator(), new UniformRandomCombinedIntegerVectorCreator(), new CombinedIntegerVectorCoveringCreator()) {
+    }
+
+    public CombinedIntegerVectorClassificationProblem(CombinedIntegerVectorClassificationProblemData problemData, XCSEvaluator evaluator, UniformRandomCombinedIntegerVectorCreator solutionCreator, ICoveringSolutionCreator coveringSolutionCreator)
+      : base(problemData, evaluator, solutionCreator, coveringSolutionCreator) {
+      Parameters.Add(new FixedValueParameter<CombinedIntegerVectorComparer>("ClassifierComparer", new CombinedIntegerVectorComparer()));
+      Parameters.Add(new FixedValueParameter<ItemSet<IAction>>("PossibleActions", new ItemSet<IAction>(ClassifierComparer)));
+      Parameters.Add(new FixedValueParameter<ItemSet<CombinedIntegerVector>>("PossibleActionsConcreteClass", new ItemSet<CombinedIntegerVector>(ClassifierComparer)));
+
+      SetProblemDataSpecificParameters();
+
+      InitializeOperators();
+
+      problemData.Changed += new System.EventHandler(problemData_Changed);
+    }
+
+    private void problemData_Changed(object sender, System.EventArgs e) {
+      SetProblemDataSpecificParameters();
+    }
+
+    private void SetProblemDataSpecificParameters() {
+      SolutionCreator.ActionPartLengthParameter.Value = ProblemData.ActionLengthParameter.Value;
+      SolutionCreator.LengthParameter.Value = ProblemData.LengthParameter.Value;
+      SolutionCreator.BoundsParameter.Value = ProblemData.BoundsParameter.Value;
+
+      SetPossibleActions();
+    }
+
+    private void InitializeOperators() {
+      Operators.AddRange(ApplicationManager.Manager.GetInstances<ICombinedIntegerVectorCrossover>());
+      Operators.AddRange(AddManipulators());
+
+      ParameterizeOperators();
+    }
+
+    private IEnumerable<ICombinedIntegerVectorManipulator> AddManipulators() {
+      var manipulator = new UniformSomePositionManipulator();
+      manipulator.ChildParameter.ActualName = ChildName;
+      manipulator.FetchedInputParameter.ActualName = ClassifierFetcher.CurrentInputToMatchParameter.ActualName;
+      manipulator.PossibleActionsParameter.ActualName = PossibleActionsConcreteClassParameter.Name;
+      return new List<ICombinedIntegerVectorManipulator>() { manipulator };
+    }
+
+    protected override void SetPossibleActions() {
+      //get bounds of action
+      IntMatrix actionBounds = GetElementsOfBoundsForAction(ProblemData.Bounds, ProblemData.Length.Value, ProblemData.ActionLength.Value);
+      int actionLength = ProblemData.ActionLength.Value;
+      int start = ProblemData.Length.Value - actionLength;
+      int[] elements = new int[actionLength];
+      int[] curPos = new int[actionLength];
+      bool done = false;
+      //initialize curPos
+      for (int i = 0; i < actionBounds.Rows; i++) {
+        curPos[i] = actionBounds[i, 0];
+      }
+      PossibleActions.Clear();
+      PossibleActionsConcreteClass.Clear();
+      while (!done) {
+        PossibleActions.Add(new CombinedIntegerVector(curPos, actionLength, actionBounds));
+        PossibleActionsConcreteClass.Add(new CombinedIntegerVector(curPos, actionLength, actionBounds));
+        curPos = GetNextAction(curPos, actionBounds, out done);
+      }
+      ThetaMinimalNumberOfActions.Value = PossibleActions.Count;
+    }
+
+    private int[] GetNextAction(int[] curPos, IntMatrix actionBounds, out bool done) {
+      int cur = 0;
+      while (cur < curPos.Length) {
+        curPos[cur] += actionBounds.Columns < 3 ? 1 : actionBounds[cur, 2];
+        if (curPos[cur] >= actionBounds[cur, 1]) {
+          curPos[cur] = actionBounds[cur, 0];
+          cur++;
+        } else {
+          break;
+        }
+      }
+      done = cur >= curPos.Length;
+      return curPos;
+    }
+
+    private IntMatrix GetElementsOfBoundsForAction(IntMatrix bounds, int length, int actionPartLength) {
+      IntMatrix actionBounds = new IntMatrix(actionPartLength, bounds.Columns);
+      int start = length - actionPartLength;
+      for (int i = start; i < length; i++) {
+        int pos = i % bounds.Rows;
+        for (int j = 0; j < bounds.Columns; j++) {
+          actionBounds[i - start, j] = bounds[pos, j];
+        }
+      }
+      return actionBounds;
+    }
+  }
+}
